package org.eclipse.jdt.internal.compiler.lookup;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.Map;
import java.util.Set;
import org.eclipse.jdt.core.compiler.CharOperation;
import org.eclipse.jdt.internal.compiler.lookup.Binding;
import org.eclipse.jdt.internal.compiler.lookup.InferenceContext18;
import org.eclipse.jdt.internal.compiler.lookup.InvocationSite;
import org.eclipse.jdt.internal.compiler.lookup.LookupEnvironment;
import org.eclipse.jdt.internal.compiler.lookup.PackageBinding;
import org.eclipse.jdt.internal.compiler.lookup.ReferenceBinding;
import org.eclipse.jdt.internal.compiler.lookup.Scope;
import org.eclipse.jdt.internal.compiler.lookup.TypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.TypeConstants;
import org.eclipse.jdt.internal.compiler.lookup.TypeVariableBinding;

public class InferenceVariable extends TypeVariableBinding {
  InvocationSite site;
  
  TypeBinding typeParameter;
  
  long nullHints;
  
  private org.eclipse.jdt.internal.compiler.lookup.InferenceVariable prototype;
  
  int varId;
  
  public static org.eclipse.jdt.internal.compiler.lookup.InferenceVariable get(TypeBinding typeParameter, int rank, InvocationSite site, Scope scope, ReferenceBinding object) {
    Map<InferenceVarKey, org.eclipse.jdt.internal.compiler.lookup.InferenceVariable> uniqueInferenceVariables = (scope.compilationUnitScope()).uniqueInferenceVariables;
    org.eclipse.jdt.internal.compiler.lookup.InferenceVariable var = null;
    InferenceVarKey key = null;
    if (site != null && typeParameter != null) {
      key = new InferenceVarKey(typeParameter, site, rank);
      var = uniqueInferenceVariables.get(key);
    } 
    if (var == null) {
      int newVarId = uniqueInferenceVariables.size();
      var = new org.eclipse.jdt.internal.compiler.lookup.InferenceVariable(typeParameter, rank, newVarId, site, scope.environment(), object);
      if (key != null)
        uniqueInferenceVariables.put(key, var); 
    } 
    return var;
  }
  
  private InferenceVariable(TypeBinding typeParameter, int parameterRank, int iVarId, InvocationSite site, LookupEnvironment environment, ReferenceBinding object) {
    this(typeParameter, parameterRank, site, CharOperation.concat(typeParameter.shortReadableName(), Integer.toString(iVarId).toCharArray(), '#'), environment, object);
    this.varId = iVarId;
  }
  
  private InferenceVariable(TypeBinding typeParameter, int parameterRank, InvocationSite site, char[] sourceName, LookupEnvironment environment, ReferenceBinding object) {
    super(sourceName, null, parameterRank, environment);
    this.site = site;
    this.typeParameter = typeParameter;
    this.tagBits |= typeParameter.tagBits & 0x180000000000000L;
    if (typeParameter.isTypeVariable()) {
      TypeVariableBinding typeVariable = (TypeVariableBinding)typeParameter;
      if (typeVariable.firstBound != null) {
        long boundBits = typeVariable.firstBound.tagBits & 0x180000000000000L;
        if (boundBits == 72057594037927936L) {
          this.tagBits |= boundBits;
        } else {
          this.nullHints |= boundBits;
        } 
      } 
    } 
    this.superclass = object;
    this.prototype = this;
  }
  
  public TypeBinding clone(TypeBinding enclosingType) {
    org.eclipse.jdt.internal.compiler.lookup.InferenceVariable clone = new org.eclipse.jdt.internal.compiler.lookup.InferenceVariable(this.typeParameter, this.rank, this.site, this.sourceName, this.environment, this.superclass);
    clone.tagBits = this.tagBits;
    clone.nullHints = this.nullHints;
    clone.varId = this.varId;
    clone.prototype = this;
    return (TypeBinding)clone;
  }
  
  public org.eclipse.jdt.internal.compiler.lookup.InferenceVariable prototype() {
    return this.prototype;
  }
  
  public char[] constantPoolName() {
    throw new UnsupportedOperationException();
  }
  
  public PackageBinding getPackage() {
    throw new UnsupportedOperationException();
  }
  
  public boolean isCompatibleWith(TypeBinding right, Scope scope) {
    return true;
  }
  
  public boolean isProperType(boolean admitCapture18) {
    return false;
  }
  
  TypeBinding substituteInferenceVariable(org.eclipse.jdt.internal.compiler.lookup.InferenceVariable var, TypeBinding substituteType) {
    if (TypeBinding.equalsEquals((TypeBinding)this, (TypeBinding)var))
      return substituteType; 
    return (TypeBinding)this;
  }
  
  void collectInferenceVariables(Set<org.eclipse.jdt.internal.compiler.lookup.InferenceVariable> variables) {
    variables.add(this);
  }
  
  public ReferenceBinding[] superInterfaces() {
    return Binding.NO_SUPERINTERFACES;
  }
  
  public char[] qualifiedSourceName() {
    throw new UnsupportedOperationException();
  }
  
  public char[] sourceName() {
    return this.sourceName;
  }
  
  public char[] readableName() {
    return this.sourceName;
  }
  
  public boolean hasTypeBit(int bit) {
    throw new UnsupportedOperationException();
  }
  
  public String debugName() {
    return String.valueOf(this.sourceName);
  }
  
  public String toString() {
    return debugName();
  }
  
  public int hashCode() {
    int code = this.typeParameter.hashCode() + 17 * this.rank;
    if (this.site != null) {
      code = 31 * code + this.site.sourceStart();
      code = 31 * code + this.site.sourceEnd();
    } 
    return code;
  }
  
  public boolean equals(Object obj) {
    if (!(obj instanceof org.eclipse.jdt.internal.compiler.lookup.InferenceVariable))
      return false; 
    org.eclipse.jdt.internal.compiler.lookup.InferenceVariable other = (org.eclipse.jdt.internal.compiler.lookup.InferenceVariable)obj;
    return (this.rank == other.rank && 
      InferenceContext18.isSameSite(this.site, other.site) && 
      TypeBinding.equalsEquals(this.typeParameter, other.typeParameter));
  }
  
  public TypeBinding erasure() {
    if (this.superclass == null)
      this.superclass = this.environment.getType(TypeConstants.JAVA_LANG_OBJECT); 
    return super.erasure();
  }
}
